#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Content::UESSheet
  private_class_method :new

  BESHEET_CODE = Java::cz.ues.core.content.UESSheet::BESHEET_CODE #:nodoc:

  # URI of sheet business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_SHEET = Java::cz.ues.core.content.UESSheet::BETYPE_SHEET


# Returns attributes representing the sheet specified by the <code>sheetUri</code> attribute.
# 
# <tt><b>param</b></tt> sheetUri URI of sheet
# 
# <tt><b>return</b></tt> DTO with sheet attributes
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(sheetUri)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getAttributes(sheetUri)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias attributes getAttributes
  end

# This command returns a list of sheets on the specified artifact. Command does not return all sheets, only a sublist. The list of
# returned sheets could be filtered by the name, code, main, order of a sheet and state of the lock. The list is sorted by the name (and
# codes in case are equal) of a sheet by default, or it can be sorted arbitrarily by any of sheet attributes usable for the filtering or
# these attributes combinations.
# 
# <tt><b>param</b></tt> artifactUri URI of artifact.
# 
# <tt><b>param</b></tt> sheetCriteria Criteria for selecting sheets. Available parameters are: UESSheetAttributes#name name,
# UESSheetAttributes#code code, UESSheetAttributes#order order, UESSheetAttributes#main main,
# UESSheetAttributes#locked locked, UESSheetAttributes#lockTime lockTime, UESSheetAttributes#visible
# visible and UESSheetAttributes#width width : UESSheetWidthType UESSheetWidthType.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List with sheets of artifact
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getSheetList(artifactUri, sheetCriteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    sheetCriteria = Ues::Core::Content::UESSheetGetSheetList.new(sheetCriteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getSheetList(artifactUri, sheetCriteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias sheet_list getSheetList
  end

# This command locks the sheet for further modification, locks the given sheet of artifact. When lock succeed or sheet is currently
# locked by the user, sheet data can be returned. Sheet lock failure throws UESSheetRTException.
# 
# <tt><b>param</b></tt> sheetUri URI of sheet to be locked.
# 
# <tt><b>param</b></tt> options Specify when stream will be returned and which type of data
# 
# <tt><b>return</b></tt> DTO contains content of sheet
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.checkOut(sheetUri, options = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    options = Ues::Core::Content::UESSheetCheckOut.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.checkOut(sheetUri, options)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias check_out checkOut
  end

# This command changes the content of the public sheet version and unlocks it by default. Sheet content is in UXML or UDF format, data
# are streamed. Sheet must be unlocked or the user must be the lock owner.
# 
# If using XML format document cannot contain links to property of object from other territory.
# 
# <tt><b>param</b></tt> sheetUri URI of the sheet.
# 
# <tt><b>param</b></tt> sheet Attributes of importing sheet
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.checkIn(sheetUri, sheet = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    sheet = Ues::Core::Content::UESSheetCheckIn.new(sheet).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.checkIn(sheetUri, sheet)
    
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias check_in checkIn
  end

# Returns the content of the sheet specified by <code>sheetUri</code>. Data are streamed. Available output data formats are UXML file,
# UDF archive, and a zip archive with the sheet content exported as HTML document (see UESSheetGetSheetData UESSheetGetSheetData
# for more details).
# 
# <tt><b>param</b></tt> sheetUri URI of the sheet.
# 
# <tt><b>param</b></tt> options Specify when stream will be returned and which type of data
# 
# <tt><b>return</b></tt> DTO with sheet content.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getSheetData(sheetUri, options = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    options = Ues::Core::Content::UESSheetGetSheetData.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getSheetData(sheetUri, options)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias sheet_data getSheetData
  end

# Command creates a new sheet in the specified artifact. Initial sheet content could be specified. Content is streamed.
# 
# <tt><b>param</b></tt> artifactUri URI of artifact
# 
# <tt><b>param</b></tt> sheet DTO with sheet content
# 
# <tt><b>return</b></tt> UES URI of created sheet
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(artifactUri, sheet = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    sheet = Ues::Core::Content::UESSheetCreate.new(sheet).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.create(artifactUri, sheet)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns the content of specified sheet component in the specified format. The result is streamed.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet
# 
# <tt><b>param</b></tt> component Specifies component id
# 
# <tt><b>return</b></tt> DTO containing the component content in a stream
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-06
# 
# <tt><b>deprecated</b></tt> since UES7-04 RFP1. Use #getComponentData(UESURI, UESSheetGetComponentContent) instead.
  def self.getComponentContent(sheetUri, component = nil)
    warn "[DEPRECATED: Ues::Core::Content::UESSheet.getComponentContent] since UES7-04 RFP1. Use #getComponentData(UESURI, UESSheetGetComponentContent) instead."
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    component = Ues::Core::Content::UESSheetGetComponentContent.new(component).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getComponentContent(sheetUri, component)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias component_content getComponentContent
  end

# Returns the content of specified sheet component in the specified format. Available output data formats are UXML file or BB code. If
# not specified, BB code is used by default. The result is streamed.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet
# 
# <tt><b>param</b></tt> component Specifies component id and type of returned data
# 
# <tt><b>return</b></tt> DTO containing the component content in a stream
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.getComponentData(sheetUri, component = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    component = Ues::Core::Content::UESSheetGetComponentData.new(component).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getComponentData(sheetUri, component)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias component_data getComponentData
  end

  # :stopdoc:
  def self.getComponentDataInternal(sheetUri, component = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    component = Ues::Core::Content::UESSheetGetComponentData.new(component).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getComponentDataInternal(sheetUri, component)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias component_data_internal getComponentDataInternal
  end
  # :startdoc:

# Replaces specified component with given content. Content is in the BB code format and it is streamed. Replace returns list of
# componentIds of inserted components. Leaves the sheet locked if preserveLock not specified.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet.
# 
# <tt><b>param</b></tt> component Specifies component id and content in BB code format
# 
# <tt><b>return</b></tt> list of componentIds of inserted components
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.replaceComponent(sheetUri, component = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    component = Ues::Core::Content::UESSheetReplaceComponent.new(component).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.replaceComponent(sheetUri, component)
    if (_r != nil) then _t = []; _r.to_a.each do |_e|; ; _t << _e; end; _r = _t; end;
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias replace_component replaceComponent
  end

# Publishes private version and opens the lock sheet. All changes made in private version are published.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.publish(sheetUri)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.publish(sheetUri)
    
    return _r
  end

# Unlocks the specified sheet. Allows to unlock the sheet locked by another user
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.unlock(sheetUri)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.unlock(sheetUri)
    
    return _r
  end

# Deletes the sheet from the system.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(sheetUri)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.delete(sheetUri)
    
    return _r
  end

# Deletes specified component from the sheet.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet.
# 
# <tt><b>param</b></tt> UESSheetDeleteComponent DTO containing attributes for deleting component.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.deleteComponent(sheetUri, component = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    component = Ues::Core::Content::UESSheetDeleteComponent.new(component).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.deleteComponent(sheetUri, component)
    
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias delete_component deleteComponent
  end

# This command updates basic attributes of an sheet.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet whose attributes are to be changed.
# 
# <tt><b>param</b></tt> sheet DTO containing the sheet attributes.
# 
# <tt><b>return</b></tt> UESURI of the changed sheet.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES7-01
  def self.setAttributes(sheetUri, sheet = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    sheet = Ues::Core::Content::UESSheetSetAttributes.new(sheet).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.setAttributes(sheetUri, sheet)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias set_attributes setAttributes
  end

# Returns attributes of given sheet version.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet whose version is being searched.
# 
# <tt><b>param</b></tt> versionAttributes DTO containing ID of the searched version.
# 
# <tt><b>return</b></tt> DTO with attributes of the searched version.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getVersionAttributes(sheetUri, versionAttributes = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    versionAttributes = Ues::Core::Content::UESSheetGetVersionAttributes.new(versionAttributes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getVersionAttributes(sheetUri, versionAttributes)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetVersionAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias version_attributes getVersionAttributes
  end

# This command returns a list of sheet versions of the specified sheet. Command does not return all sheets, only a sublist. The list of
# returned sheets could be filtered by the label, time of creation, creation stamp and version number. The list is sorted by the creation
# time in descending order by default, but it can be sorted arbitrarily by any of sheet attributes usable for the filtering or by
# combination of these attributes.
# 
# <tt><b>param</b></tt> sheetUri URI of sheet.
# 
# <tt><b>param</b></tt> versionCriteria Criteria for selecting sheets. Available parameters are: UESSheetVersionAttributes#label label,
# UESSheetVersionAttributes#creationTime creationTime, UESSheetVersionAttributes#creationStamp creationStamp,
# and UESSheetVersionAttributes#version version.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List with versions of sheet
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getVersionList(sheetUri, versionCriteria = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    versionCriteria = Ues::Core::Content::UESSheetGetVersionList.new(versionCriteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getVersionList(sheetUri, versionCriteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias version_list getVersionList
  end

# Deletes the version from the system.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet whose version is about to be deleted.
# 
# <tt><b>param</b></tt> version DTO containing ID of the version which is to be deleted.
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.deleteVersion(sheetUri, version = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    version = Ues::Core::Content::UESSheetDeleteVersion.new(version).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.deleteVersion(sheetUri, version)
    
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias delete_version deleteVersion
  end

# Deletes unlabeled historic versions of a given sheet, based on provided criteria. If olderThanTs timestamp is specified, only versions
# older than given timestamp will be deleted, otherwise will be deleted a year or more old versions. If olderThanTs is set as a date in
# the future, all unlabeled historic version will be deleted. Historic versions are deleted asynchronously, together with all the image
# mappings and images.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet, which historic versions will be deleted.
# 
# <tt><b>param</b></tt> versions DTO containing optional timestamp
# 
# <tt><b>throws</b></tt> UESSheetRTException
# 
# <tt><b>since</b></tt> UES8-25
  def self.deleteVersions(sheetUri, versions = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    versions = Ues::Core::Content::UESSheetDeleteVersions.new(versions).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.deleteVersions(sheetUri, versions)
    
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias delete_versions deleteVersions
  end

  # :stopdoc:
  def self.getImageList(sheetUri)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getImageList(sheetUri)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias image_list getImageList
  end
  # :startdoc:

# Returns streamed data of the image from the specified content.
# 
# <tt><b>param</b></tt> sheetUri <b>Not null.</b> UESURI of the sheet containing the image which should be returned.
# 
# <tt><b>param</b></tt> image Object with specific attributes.
# 
# <tt><b>return</b></tt> Object containing streamed image data.
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.getImageData(sheetUri, image = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    image = Ues::Core::Content::UESSheetGetImageData.new(image).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getImageData(sheetUri, image)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESFileHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias image_data getImageData
  end

# Retrieves the specified historical version of the given sheet in xml format.
# 
# <tt><b>param</b></tt> sheetUri UESURI of the sheet, which content will be retrieved.
# 
# <tt><b>param</b></tt> version Object containing which version of sheet will be retrieved and in which format.
# 
# <tt><b>return</b></tt> UESSheetStreamHandler, containing XML of the sheet content structure of the given version.
# 
# <tt><b>throws</b></tt> UESSheetRTException
  def self.getVersionData(sheetUri, version = nil)
    sheetUri = Ues::Core::Commons::Uri::UESURI.new(sheetUri).to_java
    version = Ues::Core::Content::UESSheetGetVersionData.new(version).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.content.UESSheet.java_class)
    _r = _s.getVersionData(sheetUri, version)
    if (_r != nil) then _r = Ues::Core::Content::UESSheetStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Content::UESSheet
    alias version_data getVersionData
  end
end
