#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Workflow::UESActivity
  private_class_method :new

  BEACTIVITY_CODE = Java::cz.ues.core.workflow.UESActivity::BEACTIVITY_CODE #:nodoc:

  # URI of activity business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_ACTIVITY = Java::cz.ues.core.workflow.UESActivity::BETYPE_ACTIVITY


# This command sets a new state for the specified activity. You can enter the state template using ues uri or by specifying its type and,
# additionally, subtype.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity
# 
# <tt><b>param</b></tt> state DTO containing attributes of new activity state
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.setState(activityUri, state = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    state = Ues::Core::Workflow::UESActivitySetState.new(state).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.setState(activityUri, state)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias set_state setState
  end

# This command returns attributes representing the activity specified by the activityUri parameter. The command does not change the state
# of the activity in the system.
# 
# <tt><b>param</b></tt> activityUri UESURI of an activity whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the activity attributes
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.getAttributes(activityUri)
    if (_r != nil) then _r = Ues::Core::Workflow::UESActivityAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias attributes getAttributes
  end

# This command creates a new activity on the specified artifact. At the very least activity template or the activity type have to be
# specified in this command.
# 
# <b>Attention:</b> No activity actions or conditions are copied from the template when the new activity is created by templateUri.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of an artifact (or a parent activity) where the new activity is created
# 
# <tt><b>param</b></tt> activity DTO containing attributes of a new activity
# 
# <tt><b>return</b></tt> UESURI of the new activity
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(parentNodeUri, activity = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    activity = Ues::Core::Workflow::UESActivityCreate.new(activity).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.create(parentNodeUri, activity)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command updates some basic attributes of an activity.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity whose attributes are to be changed
# 
# <tt><b>param</b></tt> activity DTO containing new attributes the activity
# 
# <tt><b>return</b></tt> UESURI of the activity. It could be changed because command could change name and code.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.setAttributes(activityUri, activity = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    activity = Ues::Core::Workflow::UESActivitySetAttributes.new(activity).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.setAttributes(activityUri, activity)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias set_attributes setAttributes
  end

# This command deletes an unfinished activity. Planned activity will be removed from the system, activity in progress will be set to the
# canceled state.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(activityUri)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.delete(activityUri)
    
    return _r
  end

# Returns list of all instances of the recurrent activity. Returned list does not contain any objects filtered out by executed UESQuery.
# 
# <tt><b>param</b></tt> activityUri UES URI of the activity for which instances are to be listed.
# 
# <tt><b>param</b></tt> criteria DTO containing the criteria for filtering of the result list. Criteria are defined using UESQuery. Allowed filtering
# parameters are name, code, activityType, allowExecutiveRoleChange, allowSubactivities, blockTimeInCalendar, activityStateType,
# activityStateSubtype, recurrent, termModifiable, dateFrom, dateStart, dateTo and dateFinished.
# 
# <tt><b>see</b></tt> <a href="https://plus4u.net/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC/WF_V1/UESACTIVITY" target="_blank">How to work with activities
# in UES Command</a>
# 
# <tt><b>return</b></tt> List of DTO representing activities.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES7-08
  def self.getInstanceList(activityUri, criteria = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    criteria = Ues::Core::Workflow::UESActivityGetInstanceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.getInstanceList(activityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias instance_list getInstanceList
  end

# Returns list of the activities and sub activities for the specified artifact or activity. Returned list does not contain any objects
# filtered out by executed UESQuery.
# 
# <tt><b>param</b></tt> parentNodeUri UES URI of the artifact or activity for which activities are about to be listed.
# 
# <tt><b>param</b></tt> criteria DTO containing the criteria for filtering of the result list. Criteria are defined using UESQuery. Allowed filtering
# parameters are name, code, activityType, allowExecutiveRoleChange, allowSubactivities, blockTimeInCalendar, activityStateType,
# activityStateSubtype, recurrent, termModifiable, dateFrom, dateStart, dateTo and dateFinished.
# 
# <tt><b>see</b></tt> <a href="https://plus4u.net/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC/WF_V1/UESACTIVITY" target="_blank">How to work with activities
# in UES Command</a>
# 
# <tt><b>return</b></tt> List of DTO representing activities.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES7-08
  def self.getActivityList(parentNodeUri, criteria = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    criteria = Ues::Core::Workflow::UESActivityGetActivityList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.getActivityList(parentNodeUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias activity_list getActivityList
  end

# Retrieves the list of set states on a given activity based on provided criteria.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity (model or instance), whose communication will be retrieved.
# 
# <tt><b>param</b></tt> criteria Object containing paging criteria.
# 
# <tt><b>return</b></tt> Returns list of activity states attributes. Contains instances of UESActivityStateAttributes.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.getStateHistoryList(activityUri, criteria = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    criteria = Ues::Core::Workflow::UESActivityGetStateHistoryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.getStateHistoryList(activityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias state_history_list getStateHistoryList
  end

# Returns a list of activity state templates which can be set by the current user for the specified activity.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity whose state templates will be returned for the current user.
# 
# <tt><b>param</b></tt> criteria DTO containing the criteria for filtering of the result list. Criteria are defined using UESQuery. Allowed filtering
# parameters are name, code, type, entryState, exitState, order.
# 
# <tt><b>return</b></tt> Returns a list of activity state templates which can be set by the current user for the specified activity.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES8-16
  def self.getStateTemplateList(activityUri, criteria = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    criteria = Ues::Core::Workflow::UESActivityGetStateTemplateList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.getStateTemplateList(activityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias state_template_list getStateTemplateList
  end

# Changes executive role of activity.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity to change executive role for.
# 
# <tt><b>param</b></tt> newExecutive DTO containing new executive role uri.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES8-25
  def self.setExecutiveRole(activityUri, newExecutive = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    newExecutive = Ues::Core::Workflow::UESActivitySetExecutiveRole.new(newExecutive).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.setExecutiveRole(activityUri, newExecutive)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias set_executive_role setExecutiveRole
  end

# Changes competent role of activity.
# 
# <tt><b>param</b></tt> activityUri UESURI of the activity to change competent role for.
# 
# <tt><b>param</b></tt> newCompetent DTO containing new competent role uri.
# 
# <tt><b>throws</b></tt> UESActivityRTException
# 
# <tt><b>since</b></tt> UES8-25
  def self.setCompetentRole(activityUri, newCompetent = nil)
    activityUri = Ues::Core::Commons::Uri::UESURI.new(activityUri).to_java
    newCompetent = Ues::Core::Workflow::UESActivitySetCompetentRole.new(newCompetent).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivity.java_class)
    _r = _s.setCompetentRole(activityUri, newCompetent)
    
    return _r
  end
  class << Ues::Core::Workflow::UESActivity
    alias set_competent_role setCompetentRole
  end
end
