#--
# This code is automatically generated, do not modify the content !!!
#++
# UESActivityAction is a service that provides operations related to actions of activity templates.
# 
# <tt><b>since</b></tt> UES8-07
class Ues::Core::Workflow::UESActivityAction
  private_class_method :new

  BE_ACTIVITY_ACTION_CODE = Java::cz.ues.core.workflow.UESActivityAction::BE_ACTIVITY_ACTION_CODE #:nodoc:

  # URI of UESActivityAction business entity.
  BETYPE_ACTIVITY_ACTION = Java::cz.ues.core.workflow.UESActivityAction::BETYPE_ACTIVITY_ACTION


# Creates a new activity action for the specified entity (activity template or activity instance). The parameters
# activityStateTemplateUri and the type of the activity action must be always specified. Then, according to this type,
# following parameters must be specified as well:
# 
# - for set artifact state actions, the parameter targetArtifactStateTemplateUri must be specified
# - for set activity state actions, the parameter targetActivityStateTemplateUri must be specified
# - for exec macro actions, the parameter macroUri must be specified
# 
# <tt><b>param</b></tt> entityUri UESURI of the activity template or activity instance for which the new activity action is to be created.
# 
# <tt><b>param</b></tt> activityAction Object containing attributes of the new activity action.
# 
# <tt><b>return</b></tt> UESURI of the new activity action.
# 
# <tt><b>throws</b></tt> UESActivityActionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.create(entityUri, activityAction = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    activityAction = Ues::Core::Workflow::UESActivityActionCreate.new(activityAction).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityAction.java_class)
    _r = _s.create(entityUri, activityAction)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes of the specified activity action.
# 
# <tt><b>param</b></tt> activityActionUri UESURI of the activity action whose attributes are to be returned.
# 
# <tt><b>return</b></tt> Object with attributes of the activity action.
# 
# <tt><b>throws</b></tt> UESActivityActionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getAttributes(activityActionUri)
    activityActionUri = Ues::Core::Commons::Uri::UESURI.new(activityActionUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityAction.java_class)
    _r = _s.getAttributes(activityActionUri)
    if (_r != nil) then _r = Ues::Core::Workflow::UESActivityActionAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityAction
    alias attributes getAttributes
  end

# Deletes the specified activity action.
# 
# <tt><b>param</b></tt> activityActionUri UESURI of the activity action which is to be deleted.
# 
# <tt><b>throws</b></tt> UESActivityActionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.delete(activityActionUri)
    activityActionUri = Ues::Core::Commons::Uri::UESURI.new(activityActionUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityAction.java_class)
    _r = _s.delete(activityActionUri)
    
    return _r
  end

# Returns a list of activity actions of the specified entity (activity template or activity instance)
# according to the entered criteria. Criteria are defined using query. The list of returned activity actions
# can be filtered and sorted by the type and code (or by combinations of those attributes). The list is sorted
# by the attribute type (and by code in case types are equal) of activity actions by default.
# See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> entityUri UESURI of the entity (activity template or activity instance) whose activity action list is to be returned.
# 
# <tt><b>param</b></tt> criteria Object containing paging and filtering criteria.
# 
# <tt><b>return</b></tt> List of objects representing activity actions filtered according to the entered criteria.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">
# UESQuery Documentation.</a>
# 
# <tt><b>throws</b></tt> UESActivityActionRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getActivityActionList(entityUri, criteria = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    criteria = Ues::Core::Workflow::UESActivityActionGetActivityActionList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityAction.java_class)
    _r = _s.getActivityActionList(entityUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityAction
    alias activity_action_list getActivityActionList
  end
end
