#--
# Extension used to override default generated API to be able to create new instance with plain String.
# It is used to construct UESStreamHandler without need to explicitly use UESStreamSource.
#++
class Ues::Platform::Commons::Lang::UESStreamHandler

  class << self
    alias old_supports supports
  end
  def self.supports(params) #:nodoc:
    if ((params.java_kind_of?Java::java.lang.String) || (params.java_kind_of?String) || (params.java_kind_of?"".class))
      return true
    end
    return old_supports(params)
  end

  alias old_initialize initialize

  # Creates new instance of UESStreamHandler. As parameter is accepted:
  # * Another instance of UESStreamHandler
  # * Instance of Java object cz.ues.platform.commons.lang.UESStreamHandler
  # * String value which will be converted to stream
  # * Ruby hash containing some of following parameters:
  #   * input (alias arg0) - File or instance of java.io.InputStream (deprecated)
  #   * contentType (alias arg1) - String or instance of java.lang.String (deprecated)
  #   * size (alias arg2) - Fixnum or instance of java.lang.Number (deprecated)
  #   * source (alias arg3) - Instance of cz.ues.platform.commons.lang.UESStreamSource
  def initialize(params=nil)
    if ((params != nil) && ((params.java_kind_of?Java::java.lang.String) || (params.java_kind_of?String) || (params.java_kind_of?"".class)))
      source = Java::cz.ues.platform.commons.lang.UESStringSource.new(params)
      @dtoValue = Java::cz.ues.platform.commons.lang.UESStreamHandler.new(source)
    else
      old_initialize(params)
    end
  end
  
end
