# UES Logger Factory is general factory for creating instances of logger.
#
# <tt><b>author</b></tt> uni430
#
# <tt><b>since</b></tt> UES7-02
class Ues::Platform::Commons::UESLoggerFactory
  # Returns new instance of UESLogger.
  #
  # <tt><b>param</b></tt> name Logger name (in case it does not have prefix "script." it is automatically added)
  #
  # <tt><b>return</b></tt> New instance of UESLogger
  #
  # <tt><b>author</b></tt> uni430
  #
  # <tt><b>since</b></tt> UES7-02
  def self.getLogger(name)
    logger = nil
    if (name.start_with?"script.")
      logger = Java::cz.ues.platform.commons.logging.UESLoggerFactory.getLogger(name)
    else
      logger = Java::cz.ues.platform.commons.logging.UESLoggerFactory.getLogger("script." + name)
    end
    return UESLogger.new(logger)
  end
  class << Ues::Platform::Commons::UESLoggerFactory
    alias logger getLogger
  end

end
